package _EJB_exercise;

@javax.ejb.MessageDriven(activationConfig = {
    @javax.ejb.ActivationConfigProperty(propertyName = "destinationLookup", propertyValue = "jms/MY_QUEUE"),
    @javax.ejb.ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue")
})
public class Dispatcher implements javax.jms.MessageListener {

    @javax.ejb.EJB(/*mappedName = "Hello!"*/)
    /* static */ private Service _service = null;

    @Override
    public void onMessage(javax.jms.Message message) {
        try {
            My_message my_message = (My_message) ((javax.jms.ObjectMessage) message).getObject();
            System.out.println("Reception... " + this + "... " + my_message.getWord() + " at " + my_message.getOrder());
//            if (_service == null) {
//                _service = (Service) (new javax.naming.InitialContext().lookup("Hello!"));
//            }
            _service.construct_sentence(my_message);
            if (_service.stop()) {
                _service.display_sentence();
            }

        } catch (Exception e) {
            // Error...
        }
    }
}
