package _EJB_exercise;

@javax.ejb.Singleton
@javax.ejb.Startup
public class Starter {

    public static final int Number = 10;

    private javax.jms.QueueConnectionFactory _queue_connection_factory;
    private javax.jms.Queue _queue;
    private javax.jms.QueueConnection _queue_connection;
    private javax.jms.QueueSession _queue_session;
    private javax.jms.QueueSender _queue_sender;

    @javax.annotation.PostConstruct
    public void create() {
        try {
            System.out.println("One starts immediately because of '@javax.ejb.Startup'...");
            javax.naming.Context _jndi_context = new javax.naming.InitialContext();
            _queue_connection_factory = (javax.jms.QueueConnectionFactory) _jndi_context.lookup("jms/MY_QUEUE_FACTORY");
            _queue = (javax.jms.Queue) _jndi_context.lookup("jms/MY_QUEUE");
            _queue_connection = _queue_connection_factory.createQueueConnection();
            _queue_session = _queue_connection.createQueueSession(false, javax.jms.Session.AUTO_ACKNOWLEDGE);
            _queue_sender = _queue_session.createSender(_queue);

            int i = 0;
            _queue_sender.send(_queue_session.createObjectMessage(new My_message("To ", i++)));
            _queue_sender.send(_queue_session.createObjectMessage(new My_message("be ", i++)));
            _queue_sender.send(_queue_session.createObjectMessage(new My_message("or ", i++)));
            _queue_sender.send(_queue_session.createObjectMessage(new My_message("not ", i++)));
            _queue_sender.send(_queue_session.createObjectMessage(new My_message("to ", i++)));
            _queue_sender.send(_queue_session.createObjectMessage(new My_message("be, ", i++)));
            _queue_sender.send(_queue_session.createObjectMessage(new My_message("this ", i++)));
            _queue_sender.send(_queue_session.createObjectMessage(new My_message("is ", i++)));
            _queue_sender.send(_queue_session.createObjectMessage(new My_message("the ", i++)));
            _queue_sender.send(_queue_session.createObjectMessage(new My_message("question...", i++)));
            assert (i == Number);

        } catch (Exception e) {
            // Error...
        }
    }
}
